﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Collections.ObjectModel;

namespace TileViewWithSelection
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			this.DataContext = new MainPageViewModel();
			this.AddHandler(UIElement.MouseLeftButtonUpEvent, new MouseButtonEventHandler(OnMouseLeftButtonUp), true);
		}

		private void OnMouseLeftButtonUp(object sender, MouseEventArgs e)
		{
			//Sample selection logic.
			if (e.OriginalSource as Canvas == null &&
				e.OriginalSource as ToggleButton == null)
			{
				MyItem item = null;
				if (e.OriginalSource as RadTileView == null)
				{
					item = ((e.OriginalSource as UIElement).ParentOfType<RadTileViewItem>() as MyItem);
				}
				else
				{
					var tileView = VisualTreeHelper.HitTest(e.OriginalSource as RadTileView, e.GetPosition(e.OriginalSource as RadTileView));
					if (tileView != null)
					{
						if (tileView.VisualHit as Border != null || tileView.VisualHit as TextBlock != null)
						{
							var elem = tileView.VisualHit as FrameworkElement;
							item = (elem.ParentOfType<RadTileViewItem>() as MyItem);
						}
					}
				}
				if (item != null)
				{
					item.IsSelected = !item.IsSelected;
				}
			}
		}
	}
}
